<template>
    <button :class="buttonClass" @click.stop="$emit('click')">
        <fa v-if="icon" :icon="icon" :class="{'mr-1': !!label}" />
        <span v-if="label">{{ label }}</span>
    </button>
</template>

<script>
export default {
    props: {
        label: {
            type: [String, Boolean],
            default: false
        },
        icon: {
            type: [String, Array, Boolean],
            default: false
        },
        positive: {
            type: Boolean,
            default: false
        },
        negative: {
            type: Boolean,
            default: false
        },
        warning: {
            type: Boolean,
            default: false
        },
        info: {
            type: Boolean,
            default: false
        },
        accent: {
            type: Boolean,
            default: false
        },
        cssClass: {
            type: [String, Boolean],
            default: false
        }
    },
    computed: {
        buttonClass() {
            const cssClass = ['rounded', 'fade-text-bg', 'hover:outline-none', 'focus:outline-none']

            if (this.cssClass) {
                cssClass.push(this.cssClass)

                if (!/p-|px-|pl-|pr-/g.test(this.cssClass)) {
                    cssClass.push('px-3')
                }
                if (!/p-|py-|pt-|pb-/g.test(this.cssClass)) {
                    cssClass.push('py-2')
                }
            } else {
                cssClass.push(['px-3', 'py-2'])
            }

            if (this.positive) {
                cssClass.push(['hover:bg-green-300', 'text-green-500', 'hover:text-green-600'])
            } else if (this.negative) {
                cssClass.push(['hover:bg-red-300', 'text-red-500', 'hover:text-red-600'])
            } else if (this.warning) {
                cssClass.push(['hover:bg-yellow-300', 'text-yellow-500', 'hover:text-yellow-600'])
            } else if (this.info) {
                cssClass.push(['hover:bg-blue-300', 'text-blue-500', 'hover:text-blue-600'])
            } else if (this.accent) {
                cssClass.push(['hover:bg-purple-300', 'text-purple-500', 'hover:text-purple-600'])
            } else {
                cssClass.push(['hover:bg-gray-500', 'text-gray-600', 'hover:text-gray-700'])
            }

            return cssClass
        }
    }
}
</script>
